''  *** COMPILED WITH PropBasic VERSION 00.00.97a  May 13, 2010 ***
                                                             '' Mandelbrot PBASIC Program
{ Demo of Mandelbrot Fractal                                

  by CWE                                                    
  17.05.10: Shorter Vertical Sync, only one line            
            Added: Automatic search for most interesting quadrant
                                                            
}                                                           
                                                            
                                                             '' from Beans Conway's Game of Life
                                                             '' 256x192 matrix 
                                                             '' Outputs to NTSC on Propeller Demo Board



CON                                                          'DEVICE P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq =   5000000                                       'FREQ 80_000_000





                                                             '' Define CONs
' ONE      con   65536                                       'ONE      con   65536




                                                             '' Define PINs
' SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board) 'SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board)

' VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board) 'VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board)

' CpSync   PIN 16 INPUT                                      'CpSync   PIN 16 INPUT



                                                             '' Define HUB variables
' HUB BYTE vidMem(6144)                                      'vidMem  HUB BYTE(6144) = 0

' HUB BYTE vidBuf(6144)                                      'vidBuf  HUB BYTE(6144) = 255


                                                             '' Define DATA (DATA, WDATA, LDATA)
                                                             '' none


                                                             '' Define TASKs
OBJ MonoVid: "MonoVid.spin"                                  'MonoVid  TASK



                                                             '' Define variables (LONGs only)
' vidAddr    VAR LONG                                        'vidAddr    VAR LONG

' bufAddr    VAR LONG                                        'bufAddr    VAR LONG

' x          VAR LONG                                        'x          VAR LONG

' y          VAR LONG                                        'y          VAR LONG

' seed       VAR LONG                                        'seed       VAR LONG

' temp       VAR LONG                                        'temp       VAR LONG

' temp1      VAR LONG                                        'temp1      VAR LONG

' value      VAR LONG                                        'value      VAR LONG

' xmin       var long = -131072 '-131072 '-2*one             'xmin       var long = -131072 '-131072 '-2*one

' xmax       var long = ONE                                  'xmax       var long = ONE

' ymin       var long = -98304  '-1.5                        'ymin       var long = -98304  '-1.5

' ymax       var long = 98304                                'ymax       var long = 98304

' xstep      var long                                        'xstep      var long

' ystep      var long                                        'ystep      var long

' xscreen    var long                                        'xscreen    var long

' yscreen    var long                                        'yscreen    var long

' depth2     var long                                        'depth2     var long

' help       var long                                        'help       var long

' q1         var long                                        'q1         var long

' q2         var long                                        'q2         var long

' q3         var long                                        'q3         var long

' q4         var long                                        'q4         var long



                                                             '' Variables for subroutine CountNeighbors


                                                             '' Define Subroutines
' Point          FUNC 2                                      'Point          FUNC 2

' Getdepth       FUNC 2                                      'Getdepth       FUNC 2

' logx           func 1                                      'logx           func 1

' GetQuadrant    func 4                                      'GetQuadrant    func 4

' CPlot          sub 3                                       'CPlot          sub 3



                                                             '' Start of main code
PUB __Program                                                'PROGRAM Start 'pasd
  MonoVid_COG:=MonoVid.Init(@__DATASTART)                   
  CogInit(0, @__Init, @__DATASTART)                         
                                                            
DAT                                                         
                  org           0                           
__Init                                                      
__RAM                                                       
                  mov           dira,__InitDirA             
                  mov           outa,__InitOutA             
                  jmp           #Start                      


Start                                                        'Start:

                  mov           __temp1,#MonoVid_COG_ofs & $1FF '  COGSTART MonoVid
                  movd          __temp1,#MonoVid_COG_ofs >> 9
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     

                  mov           __temp2,#300                 '  PAUSE 300                       ' Give tasks time to start
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0001                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#__L0001            


__DO_1                                                       'do


                  mov           xstep,xmax                   '  xstep = xmax - ymin
                  subs          xstep,ymin                  

                  mov           __temp1,xstep                '  xstep = xstep / 254
                  mov           __temp2,#254                
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #__L0002                    
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0003                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #__L0003                    
                  rcr           __temp2,#1                  
__L0004                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#__L0004            
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0002                                                     
                  mov           xstep,__temp4               


                  mov           ystep,ymax                   '  ystep = ymax - ymin
                  subs          ystep,ymin                  

                  mov           __temp1,ystep                '  ystep = ystep / 190
                  mov           __temp2,#190                
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #__L0005                    
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0006                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #__L0006                    
                  rcr           __temp2,#1                  
__L0007                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#__L0007            
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0005                                                     
                  mov           ystep,__temp4               




                                                             '  ' Draw it

                  mov           xscreen,#1                   '  FOR xscreen = 1 TO 254
__FOR_xscreen_1                                             

                  mov           __temp1,xscreen              '    x= xscreen * xstep
                  mov           __temp2,xstep               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0008                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0008            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           x,__temp1                   

                  adds          x,xmin                       '    inc x , xmin

                  mov           yscreen,#1                   '    FOR yscreen = 1 TO 190 '95
__FOR_yscreen_2                                             

                  mov           __temp1,yscreen              '      y = yscreen * ystep
                  mov           __temp2,ystep               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0009                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0009            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           y,__temp1                   

                  adds          y,ymin                       '      inc y, ymin


                  mov           __param1,x                   '      depth2 = getdepth x, y
                  mov           __param2,y                  
                  call          #getdepth                   
                  mov           depth2,__param1             

                  mov           __param1,depth2              '      temp = logx depth2
                  call          #logx                       
                  mov           temp,__param1               

                                                             '      temp = temp and 1
                  and           temp,#1                     


                                                             '      'if depth2 > 50 or
                                                             '       '  depth2 < 20 and
                  cmps          temp,#0 WZ, WC               '      if   temp > 0 THEN
    IF_BE         jmp           #__ELSE_1                   

                  mov           __param1,xscreen             '           CPlot xscreen, yscreen, 0
                  mov           __param2,yscreen            
                  mov           __param3,#0                 
                  call          #CPlot                      

                  jmp           #__ENDIF_1                   '         else
__ELSE_1                                                    

                  mov           __param1,xscreen             '           CPlot xscreen, yscreen, 1
                  mov           __param2,yscreen            
                  mov           __param3,#1                 
                  call          #CPlot                      


__ENDIF_1                                                    '      ENDIF


                                                             '      'break
                  adds          yscreen,#1                   '    NEXT
                  cmps          yscreen,#190 WZ, WC         
    IF_BE         jmp           #__FOR_yscreen_2            
__NEXT_yscreen_2                                            


                  adds          xscreen,#1                   '  NEXT
                  cmps          xscreen,#254 WZ, WC         
    IF_BE         jmp           #__FOR_xscreen_1            
__NEXT_xscreen_1                                            


                                                             '  'New most interesting quadrant
                  mov           __param1,#1                  '  Q1 = GetQuadrant 1, 128, 1, 190
                  mov           __param2,#128               
                  mov           __param3,#1                 
                  mov           __param4,#190               
                  call          #GetQuadrant                
                  mov           q1,__param1                 

                  mov           __param1,#128                '  Q2 = GetQuadrant 128, 256, 1, 190
                  mov           __param2,#256               
                  mov           __param3,#1                 
                  mov           __param4,#190               
                  call          #GetQuadrant                
                  mov           q2,__param1                 



                  mov           xstep,xmin                   '  xstep = xmin + xmax
                  adds          xstep,xmax                  

                  mov           __remainder,xstep            '  xstep = xstep / 2
                  and           __remainder,#1              
                  sar           xstep,#1                    


                  cmps          q1,q2 WZ, WC                 '  if q1 < q2 then
    IF_AE         jmp           #__ELSE_2                   

                                                             '     xmin = xstep + xmin
                  adds          xmin,xstep                  

                  mov           __remainder,xmin             '     xmin = xmin / 2
                  and           __remainder,#1              
                  sar           xmin,#1                     

                  mov           __param1,#128                '     Q3 = GetQuadrant 128, 256, 1, 95
                  mov           __param2,#256               
                  mov           __param3,#1                 
                  mov           __param4,#95                
                  call          #GetQuadrant                
                  mov           q3,__param1                 

                  mov           __param1,#128                '     Q4 = GetQuadrant 128, 256, 96, 190
                  mov           __param2,#256               
                  mov           __param3,#96                
                  mov           __param4,#190               
                  call          #GetQuadrant                
                  mov           q4,__param1                 

                  jmp           #__ENDIF_2                   '  else
__ELSE_2                                                    

                                                             '     xmax = xstep + xmax
                  adds          xmax,xstep                  

                  mov           __remainder,xmax             '     xmax = xmax /2
                  and           __remainder,#1              
                  sar           xmax,#1                     


                  mov           __param1,#1                  '     Q3 = GetQuadrant 1, 128, 1, 95
                  mov           __param2,#128               
                  mov           __param3,#1                 
                  mov           __param4,#95                
                  call          #GetQuadrant                
                  mov           q3,__param1                 

                  mov           __param1,#1                  '     Q4 = GetQuadrant 1, 128, 96, 190
                  mov           __param2,#128               
                  mov           __param3,#96                
                  mov           __param4,#190               
                  call          #GetQuadrant                
                  mov           q4,__param1                 

__ENDIF_2                                                    '  endif

                                                             '  'break

                  mov           ystep,ymin                   '  ystep = ymin + ymax
                  adds          ystep,ymax                  

                  mov           __remainder,ystep            '  ystep = ystep / 2
                  and           __remainder,#1              
                  sar           ystep,#1                    

                  cmps          q3,q4 WZ, WC                 '  if q3 < q4 then
    IF_AE         jmp           #__ELSE_3                   

                                                             '     ymin = ystep + ymin
                  adds          ymin,ystep                  

                  mov           __remainder,ymin             '     ymin = ymin / 2
                  and           __remainder,#1              
                  sar           ymin,#1                     

                  jmp           #__ENDIF_3                   '  else
__ELSE_3                                                    

                                                             '     ymax = ystep + ymax
                  adds          ymax,ystep                  

                  mov           __remainder,ymax             '     ymax = ymax /2
                  and           __remainder,#1              
                  sar           ymax,#1                     


__ENDIF_3                                                    '  endif


                  jmp           #__DO_1                      'loop
__LOOP_1                                                    



                  mov           __temp1,#0                   'END
                  waitpne       __temp1,__temp1             






GetQuadrant                                                  'Func GetQuadrant

'   qsum var long                                            '  qsum var long

'   pix  var long                                            '  pix  var long

'   oldpix var long                                          '  oldpix var long

'   x1     var long                                          '  x1     var long

'   x2     var long                                          '  x2     var long

'   y1     var long                                          '  y1     var long

'   y2     var long                                          '  y2     var long



                  mov           qsum,#0                      '  qsum=0

                  mov           x1,__param1                  '  x1 = __param1

                  mov           x2,__param2                  '  x2 = __param2

                  mov           y1,__param3                  '  y1 = __param3

                  mov           y2,__param4                  '  y2 = __param4


                  mov           help,__param4                '  help = __param4



                  mov           xscreen,x1                   '  for xscreen = x1 to x2
__FOR_xscreen_3                                             

                  mov           yscreen,y1                   '    for yscreen = y1 to y2
__FOR_yscreen_4                                             

                  mov           __param1,xscreen             '        pix = point xscreen, yscreen
                  mov           __param2,yscreen            
                  call          #point                      
                  mov           pix,__param1                

                  cmps          pix,oldpix WZ, WC            '        if pix <> oldpix then
    IF_E          jmp           #__ELSE_4                   

                  adds          qsum,#1                      '          inc qsum

__ELSE_4                                                     '         endif
__ENDIF_4                                                   

                  mov           oldpix,pix                   '         oldpix = pix

                                                             '         'break
                  adds          yscreen,#1                   '    next yscreen
                  cmps          yscreen,y2 WZ, WC           
    IF_BE         jmp           #__FOR_yscreen_4            
__NEXT_yscreen_4                                            

                                                             '    'break
                  adds          xscreen,#1                   '  next xscreen
                  cmps          xscreen,x2 WZ, WC           
    IF_BE         jmp           #__FOR_xscreen_3            
__NEXT_xscreen_3                                            

                                                             '  'toggle 17
                  mov           __param1,qsum                '  return qsum
GetQuadrant_ret                                             
                  ret                                       

                                                             '  'break
                                                             'endfunc





Logx                                                         'Func Logx 'Log of __param1

                  mov           temp,#0                      '     temp= 0

__DO_2                                                       '     do

                  mov           __temp1,__param1             '       __param1 = __param1 * 7
                  mov           __temp2,#7                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0010                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0010            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           __param1,__temp1            

                  mov           __remainder,__param1         '       __param1 = __param1 / 8
                  and           __remainder,#7              
                  sar           __param1,#3                 

                  adds          temp,#1                      '       inc temp

                  cmps          __param1,#1 WZ, WC           '     loop until __param1 < 1
    IF_AE         jmp           #__DO_2                     

                  mov           __param1,temp                '     return temp
Logx_ret                                                    
                  ret                                       


                                                             'endfunc





Getdepth                                                     'Func Getdepth 'xa, yb


'   _x   var long=0     '    double x = 0, x2, y = 0;        '  _x   var long=0     '    double x = 0, x2, y = 0;

'   _x2  var long=0                                          '  _x2  var long=0

'   _y   var long=0                                          '  _y   var long=0

'   n    var long=0                                          '  n    var long=0

'   _temp var long                                           '  _temp var long

'   _temp2 var long                                          '  _temp2 var long



                  mov           _x,#0                        '  _x = 0

                  mov           _y,#0                        '  _y = 0

                  mov           _x2,#0                       '  _x2 = 0


                  mov           n,#0                         '  for n = 0 to 64    'for (int n = 0; n < 400; n++) {
__FOR_n_5                                                   

                  mov           __temp1,_x                   '     _x2 = _x */ _x   'x2 = x * x - y * y + a;
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0011                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0011            
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _x2,__temp1                 

                  mov           __temp1,_y                   '     _temp = _y */ _y
                  mov           __temp2,_y                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0012                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0012            
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp,__temp1               

                  subs          _x2,_temp                    '     dec _x2, _temp

                  adds          _x2,__param1                 '     inc _x2, __param1


                  mov           __temp1,_y                   '     _y = _y */ _x   'y = 2 * x * y + b;
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0013                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0013            
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _y,__temp1                  

                  shl           _y,#1                        '     _y = _y * 2

                  adds          _y,__param2                  '     inc _y , __param2


                  mov           _x,_x2                       '     _x = _x2        'x = x2;


                  mov           __temp1,_x                   '     _temp = _x */ _x         'if (x * x + y * y > 4)
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0014                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0014            
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp,__temp1               

                  mov           __temp1,_y                   '     _temp2 = _y */ _y
                  mov           __temp2,_y                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0015                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0015            
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp2,__temp1              

                  adds          _temp,_temp2                 '     inc _temp , _temp2


                  cmps          _temp,_262144 WZ, WC         '     if _temp > 262144 then '4*65536
    IF_BE         jmp           #__ELSE_5                   

                  jmp           #__NEXT_n_5                  '        exit

__ELSE_5                                                     '     endif
__ENDIF_5                                                   

                  adds          n,#1                         '  next n
                  cmps          n,#64 WZ, WC                
    IF_BE         jmp           #__FOR_n_5                  
__NEXT_n_5                                                  


                  mov           __param1,n                   '  return n
Getdepth_ret                                                
                  ret                                       


                                                             'endfunc





Point                                                        'FUNC Point ' X, Y

                  mov           __param3,par                 '  __param3 = GetAddr VidMem

                                                             '  __param2 = __param2 << 5        ' y = y * 32 bytes per row
                  shl           __param2,#5                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (y * 32)
                  adds          __param3,__param2           


                  mov           __param2,__param1            '  __param2 = __param1 >> 3        ' x / 8
                  shr           __param2,#3                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (x / 8)
                  adds          __param3,__param2           


                  rdbyte        __param2,__param3            '  RDBYTE __param3, __param2       ' Read pixels at location


                                                             '  __param1 = __param1 & 7         ' X AND 7 (pixel position within byte)
                  and           __param1,#7                 

                  mov           __temp1,__param1             '  __param1 = 1 << __param1        ' Shift to make pixel mask
                  mov           __param1,#1                 
                  shl           __param1,__temp1            


                                                             '  __param1 = __param1 AND __param2 
                  and           __param1,__param2           

                  cmps          __param1,#0 WZ, WC           '  IF __param1 <> 0 THEN
    IF_E          jmp           #__ELSE_6                   

                  mov           __param1,#1                  '    __param1 = 1

__ELSE_6                                                     '  ENDIF
__ENDIF_6                                                   

Point_ret                                                    '  RETURN __param1
                  ret                                       

                                                             'ENDFUNC


CPlot                                                        'SUB CPlot ' X (__param1), Y(__param2), Color

                  mov           temp1,__param3               '  Temp1 = __param3

                  mov           __param3,par                 '  __param3 = GetAddr VidMem 'VidBuf

                                                             '  __param2 = __param2 << 5        ' y = y * 32 bytes per row
                  shl           __param2,#5                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (y * 32)
                  adds          __param3,__param2           


                  mov           __param2,__param1            '  __param2 = __param1 >> 3        ' x / 8
                  shr           __param2,#3                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (x / 8)
                  adds          __param3,__param2           


                  rdbyte        __param2,__param3            '  RDBYTE __param3, __param2       ' Read pixels at location


                                                             '  __param1 = __param1 & 7         ' X AND 7 (pixel position within byte)
                  and           __param1,#7                 

                  mov           __temp1,__param1             '  __param1 = 1 << __param1        ' Shift to make pixel mask
                  mov           __param1,#1                 
                  shl           __param1,__temp1            

                  cmps          temp1,#1 WZ, WC              '  if temp1 = 1 then
    IF_NE         jmp           #__ELSE_7                   

                                                             '     __param2 = __param2 OR __param1 ' Xor byte with pixel mask
                  or            __param2,__param1           

                  jmp           #__ENDIF_7                   '  else
__ELSE_7                                                    

                                                             '     __param2 = __param2 andn __param1
                  andn          __param2,__param1           

__ENDIF_7                                                    '  endif

                  wrbyte        __param2,__param3            '  WRBYTE __param3, __param2       ' Save pixels back

CPlot_ret                                                    'ENDSUB
                  ret                                       
                                                            




'**********************************************************************
__InitDirA       LONG %00000000_00000000_01010000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
SyncPin          LONG 1 << 12
VideoPin         LONG 1 << 14
_65536          
ONE              LONG 65536
CpSync           LONG 1 << 16
_1mSec           LONG 80000
_262144          LONG 262144
_FREQ            LONG 80000000

xmin             LONG -131072
xmax             LONG 65536
ymin             LONG -98304
ymax             LONG 98304
_x               LONG 0
_x2              LONG 0
_y               LONG 0
n                LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
vidAddr          RES 1
bufAddr          RES 1
x                RES 1
y                RES 1
seed             RES 1
temp             RES 1
temp1            RES 1
value            RES 1
xstep            RES 1
ystep            RES 1
xscreen          RES 1
yscreen          RES 1
depth2           RES 1
help             RES 1
q1               RES 1
q2               RES 1
q3               RES 1
q4               RES 1
qsum             RES 1
pix              RES 1
oldpix           RES 1
x1               RES 1
x2               RES 1
y1               RES 1
y2               RES 1
_temp            RES 1
_temp2           RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  vidMem_ofs                       = 0
  vidBuf_ofs                       = 6144
  MonoVid_COG_ofs                  = 12288

' TASK MonoVid                                               'TASK MonoVid



DAT
__DATASTART
vidMem           BYTE 0[6144]
vidBuf           BYTE 255[6144]
MonoVid_COG      LONG 0


